import java.io.*;
import hpjava.*;


public class Life extends Node {
  static final int N      = 9;
  static final int NITER  = 50;
  static final String [] hosts = {"koum", "naos", "koum", "naos"};

  public static void main(String args[]) {
    HPJavaInit(args, hosts) ;

    Procs p = new Procs(this, 2, 2);
    Range x = new Range(N, Range.BLOCK, p, 0);
    Range y = new Range(N, Range.BLOCK, p, 1);
    Ranges r = new Ranges(x, y);
    int xys = r.seg();
    int[] w = new int[xys];
    int[] cn_ = new int[xys];
    int[] cp_ = new int[xys];
    int[] c_n = new int[xys];
    int[] c_p = new int[xys];
    int[] cnn = new int[xys];
    int[] cnp = new int[xys];
    int[] cpn = new int[xys];
    int[] cpp = new int[xys];
    int M = N/2;
    for(r.forall(); r.test(); r.next()) {
      w[r.sub()] = ((r.idx(0) == M)||(r.idx(1) == M)) ? 1 : 0;
    }
    shift(cn_, w, r, 0,  1, CYCLIC);
    shift(cp_, w, r, 0, -1, CYCLIC);
    shift(c_n, w, r, 1,  1, CYCLIC);
    shift(c_p, w, r, 1, -1, CYCLIC);
    shift(cnn, cn_, r, 1,  1, CYCLIC);
    shift(cnp, cn_, r, 1, -1, CYCLIC);
    shift(cpn, cp_, r, 1,  1, CYCLIC);
    shift(cpp, cp_, r, 1, -1, CYCLIC);
    for(r.forall(); r.test(); r.next()) {
      int xy = r.sub();
      switch (cn_[xy]+cp_[xy]+c_n[xy]+c_p[xy]+
        cnn[xy]+cnp[xy]+cpn[xy]+cpp[xy]) {
        case 2 : break;
        case 3 : w[xy] = 1; break;
        default: w[xy] = 0; break;
      }
    }

    concatenate(0, w_seq, w) ;

    if(id == 0)
      print w_seq ;

}

public class Node {
  static DataInputStream[] fromNode;

  Port[][] port = new Port[NNODE][NNODE];

  static int NNODE ;


  static void HPJavaInit(String [] args, String [] hosts) {
    int i, j;
    fromNode = new DataInputStream[NNODE];

    if(args doesn't include -%X_$IS_WORKER!)
      for (i=1; i<NNODE; i++) 
      for (j=0; j<i; j++) {
	port[i][j] = new Port();
	port[j][i] = new Port();
	Port.channel(port[i][j], port[j][i]);
      }
      for (i=1; i<NNODE; i++) {
	Port U = new Port() ;
	Port V = new Port() ;
	Port.channel(U, V) ;
	RPC.spawn(this.getClass().genName(), hosts [i - 1],
                  args + "-%X_$IS_WORKER!", V) ;
	U.sendInt(NNODE) ;
	U.sendInt(i) ;
	for (j=0; j<NNODE; j++)
	  if (j != i) U.sendChan(port[j][i]);

	fromNode[i] = new DataInputStream(new PortInputStream(U));
	System.out.println("OK");
        id = 0 ;
      }
    else {
      np = initial.recvInt() ;
      id = initial.recvInt() ;
      port = new Port[np];
      toNode = new DataOutputStream[np];
      fromNode = new DataInputStream[np];
      for (int i=0; i<np; i++) {
        if ( i != id ) {
          initial.recvChan(port[i] = new Port());
          fromNode[i] = new DataInputStream(new PortInputStream(port[i]));
          toNode[i] = new DataOutputStream(new PortOutputStream(port[i]));
        }
      }
      toHost = new DataOutputStream(new PortOutputStream(initial));
   }

  }

  static void CollectResult() {
    try {
      int i, j;
      for (i=0; i<NNODE; i++) {
        System.out.println("Processor No."+i);
        int xseg = fromNode[i].readInt();
        int yseg = fromNode[i].readInt();
        for (int y=0; y<yseg; y++) {
          for (int x=0; x<xseg; x++)
            System.out.print(fromNode[i].readInt()+" ");
          System.out.println();
        }
      }
    } catch ( Exception e ) {
      System.out.println("I/O Error!");
    }
  }
}

import java.io.*;
import hpjava.*;

public class HPJW extends Node {

  public static void main(String args[]) { Initialize();}

  HPJW(int N, int NITER) {
  }
}

class Node extends Child {
  final static int CYCLIC = 0;
  final static int EDGE = 1;
  static int id, np;
  static Port[] port;
  static DataInputStream[] fromNode;
  static DataOutputStream[] toNode;
  static DataOutputStream toHost;

  static void Initialize() {
    try {
      new HPJW(initial.recvInt(), initial.recvInt());
    } catch ( Exception e ) {
      System.out.println("Something Wrong!");
    }
  }

  void shift(int[] dst, int[] src, Ranges r,
    int dim, int delta, int mode) {
    int rid, nid, n, brnp = r.brnp(dim);
    Range s = r.range[dim];
    for(s.forall(); s.test(); s.next()) {
      n = s.idx()+delta;
      rid = (mode == EDGE) ? s.kid(n) : s.rid(n);
      if ((rid != s.rid) && (rid != -1)) {
        nid = (id+(rid-s.rid)*brnp+np)%np;
        try {
          toNode[nid].writeInt(s.cyclic(n));
          for(r._forall(dim); r._test(); r._next())
            toNode[nid].writeInt(src[r.sub()]);
          toNode[nid].flush();
        } catch ( Exception e ) {
          System.out.println("I/O Error!");
        }
      }
    }
    for(s.forall(); s.test(); s.next()) {
      n = s.idx()-delta;
      rid = (mode == EDGE) ? s.kid(n) : s.rid(n);
      if ( rid == s.rid ) {
        n = s.sub(s.cyclic(n));
        for(r._forall(dim); r._test(); r._next())
          dst[r.sub()] = src[r.sub(n)];
      } else {
        if (rid != -1) {
          nid = (id+(rid-s.rid)*brnp+np)%np;
          try {
            n = s.sub(fromNode[nid].readInt());
            for(r._forall(dim); r._test(); r._next())
              dst[r.sub(n)] = fromNode[nid].readInt();
          } catch ( Exception e ) {
            System.out.println("I/O Error!");
          }
        }
      }
    }
  }

}

class Procs {
  int[] nps, ids;
  Procs(Node node, int x1) {
    int[] _nps = {x1};
    initialize(node, _nps);
  }
  Procs(Node node, int x1, int x2) {
    int[] _nps = {x1, x2};
    initialize(node, _nps);
  }
  Procs(Node node, int x1, int x2, int x3) {
    int[] _nps = {x1, x2, x3};
    initialize(node, _nps);
  }
  Procs(Node node, int x1, int x2, int x3, int x4) {
    int[] _nps = {x1, x2, x3, x4};
    initialize(node, _nps);
  }
  void initialize(Node _node, int[] _nps) {
    nps = _nps;
    ids = new int[nps.length];
    int id = _node.id;
    int i = 0;
    ids[i] = id % nps[i];
    for (i=1; i<nps.length; i++) {
      id /= nps[i-1];
      ids[i] = id % nps[i];
    }
  }
}

class Ranges {
  int segment, index, subseg, subidx, base, dim;
  Range[] range;
  Ranges(Range r1) {
    Range[] _range = {r1};
    Initialize(_range);
  }
  Ranges(Range r1, Range r2) {
    Range[] _range = {r1, r2};
    Initialize(_range);
  }
  Ranges(Range r1, Range r2, Range r3) {
    Range[] _range = {r1, r2, r3};
    Initialize(_range);
  }
  Ranges(Range r1, Range r2, Range r3, Range r4) {
    Range[] _range = {r1, r2, r3, r4};
    Initialize(_range);
  }
  void Initialize(Range[] _range) {
    range = _range;
    segment = 1;
    for (int i=0; i<range.length; i++)
      segment *= range[i].segment;
  }
  int seg() { return segment;}
  int _seg() { return segment/range[dim].segment;}
  int seg(int dim) { return range[dim].segment;}
  int idx(int dim) { return range[dim].idx();}
  int sub() { return index;}
  int sub(int val) { return index+(val-range[dim].index)*base;}
  int _sub() { return subidx;}
  boolean test() { return (index < segment);}
  boolean _test() { return (subidx < subseg);}
  void forall() {
    index = 0;
    for (int i=0; i<range.length; i++)
      range[i].index = 0;
  }
  int brnp(int _dim) {
    int result = 1;
    for (int i=0; i<_dim; i++) result *= range[i].rnp;
    return result;
  }
  void _forall(int _dim) {
    int i;
    dim = _dim;
    base = 1;
    subseg = _seg();
    subidx = 0;
    for (i=0; i<dim; i++) base *= range[i].segment;
    for (i=0; i<range.length; i++)
      if (i != dim) range[i].index = 0;
    index = range[dim].index*base;
  }
  void _forall(int _dim, int value) {
    range[_dim].index = value;
    _forall(_dim);
  }
  void next() {
    index++;
    for (int i=0; i<range.length; i++) {
      range[i].index++;
      if (range[i].test()) break;
      range[i].index = 0;
    }
  }
  void _next() {
    subidx++;
    index++;
    for (int i=0; i<range.length; i++) {
      if (i == dim) {
        index+=(range[dim].segment-1)*base;
        continue;
      }
      range[i].index++;
      if (range[i].test()) break;
      range[i].index = 0;
    }
  }
}

class Range {
  final static int BLOCK = 0;
  final static int CYCLIC = 1;
  int limit, type, start, index;
  int rid, rnp, segment, segMax;
  Range(int _limit, int _type, Procs p, int dim) {
    rid = p.ids[dim];
    rnp = p.nps[dim];
    limit = _limit;
    type = _type;
    segment = segMax = (limit+rnp-1)/rnp;
    if ( type == BLOCK ) {
      start = rid*segMax;
      if (start+segMax > limit) segment = limit-start;
    } else {
      start = rid;
      if (start+(segMax-1)*rnp >= limit) segment--;
    }
  }
  int cyclic(int idx) { return (idx+limit)%limit;}
  int seg() { return segment;}
  int idx() { return (type == BLOCK) ? start+index : start+index*rnp;}
  int rid(int idx) { return (type == BLOCK) ? cyclic(idx)/segMax : cyclic(idx)%rnp;}
  int kid(int idx) {
    if ((idx < 0) || (idx >= limit)) return -1;
    return (type == BLOCK) ? idx/segMax : idx%rnp;
  }
  int sub(int idx) { return (type == BLOCK) ? idx-start : (idx-start)/rnp;}
  int sub() { return index;}
  boolean test() { return (index < segment);}
  void forall() { index = 0;}
  void next() { index++;}
}
